#version GLSL_VERSION

/*==============================================================================
                                    VARS
==============================================================================*/
#var ALPHA 0

/*==============================================================================
                                   INCLUDES
==============================================================================*/

#include <precision_statement.glslf>
#include <std.glsl>
#include <color_util.glslf>

/*==============================================================================
                                   UNIFORMS
==============================================================================*/

uniform vec4 u_diffuse_color;

/*==============================================================================
                                SHADER INTERFACE
==============================================================================*/

//------------------------------------------------------------------------------

GLSL_OUT vec4 GLSL_OUT_FRAG_COLOR;

/*==============================================================================
                                    MAIN
==============================================================================*/

void main() {

    vec3 color = u_diffuse_color.xyz;
    float alpha = u_diffuse_color.a;

    lin_to_srgb(color);
#if ALPHA
    premultiply_alpha(color, alpha);
#endif

    GLSL_OUT_FRAG_COLOR = vec4(color, alpha);
}
